"""
This script demonstrate how to achieve Retrieval Augmented Generation [RAG] by
integrating keras_nlp package with llama index and hugging face.

In this script we will use llm from keras_nlp and integrate it with llama index
using its CustomLLM class. To load and process data we will use different functionalities
of llama index. To generate vector emebddings we will use model from huggingface.

In RAG, we have 3 main components:
----------------------------------
Vector Embedding or Embedding:
    Vector [Numerical] representation of given text data.
    Need to use LLM or Embedding model to generate this.

Retriver:
    Based on vector embedding, retriver will retrive relevant documents/text for
    the given query.

Generator:
    Large Language Model [LLM]. It will generate the answer from retrived docs/texts.


Package Versions:
-----------------
tf-keras==2.17.0
keras_nlp==0.14.4
llama_index==0.11.17
llama-index-embeddings-huggingface==0.3.1
faiss-cpu==1.9.0
sentence-transformers==3.2.0

Reference:
----------
https://docs.llamaindex.ai/en/stable/module_guides/models/llms/usage_custom/#example-using-a-custom-llm-model-advanced
https://docs.llamaindex.ai/en/stable/api_reference/llms/custom_llm/
https://docs.llamaindex.ai/en/stable/module_guides/supporting_modules/settings/
"""

# Import required packages
# ======================================================================================================================
import keras_nlp
from llama_index.core import Settings
from typing import Any
from llama_index.core.node_parser import SentenceSplitter
from llama_index.core.llms.callbacks import llm_completion_callback
from llama_index.core import (
    SimpleDirectoryReader,
    VectorStoreIndex,
    PromptHelper,
    StorageContext,
    load_index_from_storage,
    Document,
)
from llama_index.embeddings.huggingface import HuggingFaceEmbedding
from llama_index.core.llms import (
    CustomLLM,
    CompletionResponse,
    CompletionResponseGen,
    LLMMetadata,
)


# Define global vaiables
# ======================================================================================================================

# Define keras_nlp model to be used with Llama-Index
# .............................................................................
gpt2 = keras_nlp.models.GPT2CausalLM.from_preset("gpt2_extra_large_en")


# Define required class and functions
# ======================================================================================================================
class GPT2LLM(CustomLLM):
    """
    A class which overrides CustomLLM class from Llama-Index.
    This CustomLLM class is useful when we want to define custom llm. This custom
    llm can be private/local API or private/local model as well.
    """

    num_output: int = 512
    modelName: str = "GPT2 Large Model"
    model: Any = None

    # Initialize the class based on given information provided via class' object creation.
    def __init__(self, model: Any, num_output: int) -> None:
        """
        Parameters
        ==========
            self: object
                self object instantiated

            model: Any
                LLM model that we want to use with Llama Index for answer generation

            num_output: int
                Length of the text generated via LLM
        """
        super().__init__()
        self.model = model
        self.num_output = num_output

    @property
    def metadata(self) -> LLMMetadata:
        """Provide LLM metadata."""
        return LLMMetadata(num_output=self.num_output, modelName=self.modelName)

    @llm_completion_callback()
    def complete(self, prompt: str, **kwargs: Any) -> CompletionResponse:
        """
        Parameters
        ==========
            self: object
                self object instantiated

            prompt: str
                Prompt or query that will be supplied to LLM

            kwargs: Any
                Any other extra inputs provided while calling the method

        Returns
        =======
            CompletionResponse: class

                Text generated by LLM
        """
        gen_text = self.model.generate(prompt, max_length=self.num_output)
        return CompletionResponse(text=gen_text)

    @llm_completion_callback()
    def stream_complete(self, prompt: str, **kwargs: Any) -> CompletionResponseGen:
        """
        Parameters
        ==========
            self: object
                self object instantiated

            prompt: str
                Prompt or query that will be supplied to LLM

            kwargs: Any
                Any other extra inputs provided while calling the method

        Returns
        =======
            CompletionResponse: class

                Text generated by LLM
        """
        response = ""
        for token in self.model.generate(prompt, max_length=self.num_output):
            response += token
            yield CompletionResponse(text=response, delta=token)


llama_gpt2 = GPT2LLM(model=gpt2, num_output=512)

# print("Response generated by calling GPT2 model")
# print(gpt2.generate("What is artificial intelligence?"))

# print("Response generated by calling GPT2 model using LlamaIndex CustomClass")
# print(llama_gpt2.complete("What is artifical intelligence?").text)


# Define global context for LLM and Embedings models
# ======================================================================================================================
Settings.llm = llama_gpt2
Settings.embed_model = HuggingFaceEmbedding(
    model_name="sentence-transformers/all-MiniLM-L6-v2"
)
Settings.text_splitter = SentenceSplitter(chunk_size=4096, chunk_overlap=100)
#  helps with truncating and repacking text chunks to fit in the LLM’s context window
Settings.prompt_helper = PromptHelper(
    context_window=4096, num_output=512, chunk_overlap_ratio=0.1, chunk_size_limit=None
)


# Data Loading, Vector Embeddings Generation, Processing
# ======================================================================================================================
# Incase we want entire text file as single document we can use below code.
# documents = SimpleDirectoryReader(input_dir="/home/nayan/NLP/RAG/Scripts", required_exts=[".txt"]).load_data()

# Below code is to consider each sentence as separate document
# ..................................................................................................
# Read the text file and split into sentences
with open("/home/nayan/NLP/RAG/Scripts/sentences.txt", "r") as file:
    text = file.read()

# Assuming the sentences are separated by periods. Adjust as needed.
sentences = text.split(".")  # Split based on your preferred delimiter
print(type(sentences))  # It will be list data type

# Create Document objects for each sentence
documents = [Document(text=sentence) for sentence in sentences if sentence.strip()]
# ..................................................................................................

# Generate vector embedings using the model defined by Settings.embed_model
index = VectorStoreIndex.from_documents(
    documents,
    transformations=[SentenceSplitter(chunk_size=4096, chunk_overlap=100)],
)

# store the index at specified location
# index.storage_context.persist(persist_dir="/home/nayan/NLP/RAG/Scripts/index")


# Load index and generate the asnwer
# ======================================================================================================================
# rebuild storage context
# storage_context = StorageContext.from_defaults(persist_dir="/home/nayan/NLP/RAG/Scripts/index")
# load index
# index = load_index_from_storage(storage_context)

query_engine = index.as_query_engine()
response = query_engine.query("Where is silver kite dancing?")
print("*" * 108)
print(response)
print("*" * 108)
print("Out of conetext question.")
print(query_engine.query("What is artificial intelligence?"))
